<template>
  <v-avatar
    v-if="type === 'photo'"
    :image="image"
    :size="size"
    :start="start"
  />

  <v-avatar
    v-else-if="type === 'monogram'"
    :size="size"
    :start="start"
    :color="getColor()"
  >
    <span :class="getFontSize()" class="font-medium text-onSurface">
      {{ firstname?.substring(0, 1) }}
    </span>
  </v-avatar>

  <v-avatar
    v-else-if="type === 'anonym'"
    :image="anonym"
    :size="size"
    :start="start"
  />

  <v-avatar
    v-else-if="type === 'check'"
    :size="size"
    :start="start"
    rounded="circle"
    color="primary"
  >
    <Icon
      class="text-onPrimary"
      :width="(size * 2) / 3"
      :height="(size * 2) / 3"
      icon="mingcute:check-line"
    />
  </v-avatar>
</template>

<script setup>
import { ref, watch } from "vue";
import { Icon } from "@iconify/vue";
import checkImageStatus from "@/tools/imageStatus.js";
import anonym from "../../assets/anonym.svg"

const props = defineProps({
  type: {
    type: String,
    default: 'monogram',
  },
  image: {
    type: String,
    default: undefined,
  },
  firstname: {
    type: String,
    default: undefined,
  },
  size: {
    type: Number,
    default: 88
  },
  start: {
    type: Boolean,
    default: false,
  }
})

const display_avatar = ref(true);

checkImageStatus(props.image, (exists) => {
  display_avatar.value = exists;
});

const getColor = () => {
  let startingLetter = props.firstname?.substring(0, 1)?.toUpperCase()

  if (startingLetter === "A" || startingLetter === "B" || startingLetter === "C") {
    return "avatarBg1"
  } else if (startingLetter === "D" || startingLetter === "E" || startingLetter === "F") {
    return "avatarBg2"
  } else if (startingLetter === "G" || startingLetter === "H" || startingLetter === "I") {
    return "avatarBg3"
  } else if (startingLetter === "J" || startingLetter === "K" || startingLetter === "L") {
    return "avatarBg4"
  } else if (startingLetter === "M" || startingLetter === "N" || startingLetter === "O") {
    return "avatarBg5"
  } else if (startingLetter === "P" || startingLetter === "Q" || startingLetter === "R") {
    return "avatarBg6"
  } else if (startingLetter === "S" || startingLetter === "T" || startingLetter === "U" || startingLetter === "V") {
    return "avatarBg7"
  } else {
    return "avatarBg8"
  }
}

const getFontSize = () => {
  let avatarSize = props.size

  if (avatarSize === 16) {
    return "text-[10px]"
  } else if (avatarSize === 20) {
    return "text-xs"
  } else if (avatarSize === 24) {
    return "text-xs"
  } else if (avatarSize === 32) {
    return "text-sm"
  } else if (avatarSize === 40) {
    return "text-base"
  } else if (avatarSize === 64) {
    return "text-2xl"
  } else if (avatarSize === 88) {
    return "text-[34px]"
  } else {
    return "text-base"
  }
}

watch(
  () => props.image,
  () => {
    checkImageStatus(props.image, (exists) => {
      display_avatar.value = exists;
    });
  }
);
</script>